
global_settings
{
  assumed_gamma 1.0
}                                                                 

#include "colors.inc" 
#include "glass.inc"
#include "metals.inc"



#local zoom=1.5;
#local camera_pos=<2, 2, 15>;

// ----------------------------------------
camera
{
  location  camera_pos
  direction 1.5*z
  right     4/3*x*1/zoom
  up            y*1/zoom
  look_at   <2.0, 2.0,  0.0>  
}

sky_sphere
{
  pigment
  {
    gradient y
    color_map { [0.0 color rgb <0.5,0.4,1>] [1.0 color blue 0.6] }
  }
}

light_source
{
  0*x // light's position (translated below)
  color rgb <1,1,1>  // light's color
  translate <20, 20, -10>
}


light_source
{
  0*x // light's position (translated below)
  color rgb <0.6,0.6,0.6>  // light's color
  translate <-20, 20, 10>
}
   
#default{ texture{ finish  { ambient       .1
                             diffuse       .6
                             phong         .75
                             phong_size  50
                           } 
                 }   
        }                                  
        
#declare texture_R = texture { pigment { color Red } }              
#declare texture_G = texture { pigment { color Green } }              
#declare texture_B = texture { pigment { color Blue } }              
#declare texture_Y = texture { pigment { color Yellow } }              
#declare texture_M = texture { pigment { color Magenta } }              
#declare texture_C = texture { pigment { color Cyan } }              
#declare texture_NavyBlue = texture { pigment { color NavyBlue } }              

   
#include "geometry.inc"

//------------------------------------------------------------------------------------------  
                                                                                        

draw_origin(camera_pos)
            
plane { <0,0,1> 0 
        texture { mm_paper(0.3) }
      }  

#declare corner_1=<3.5,4,3>;                 
#declare corner_2=<-1,2,1>;                 
#declare corner_3=<4.5,0,4>;                 

draw_line (corner_1, corner_2, 0.03, texture_C)
draw_line (corner_2, corner_3, 0.03, texture_C)
draw_line (corner_3, corner_1, 0.03, texture_C)
                   
#local v1=vnormalize(corner_1-triangle_H(corner_1, corner_2, corner_3));                   
text { ttf "arial.ttf" "A" 1, 0
       texture { texture_NavyBlue }     
       translate <-0.35,-0.35,-0.5>
       parallelize(<0,0,-1>, triangle_normal(corner_1, corner_2, corner_3))
       scale <0.5,0.5,0.2>
       translate 0.2*v1+corner_1
     }     
#local v1=vnormalize(corner_2-triangle_H(corner_1, corner_2, corner_3));                   
text { ttf "arial.ttf" "B"1, 0
       texture { texture_NavyBlue }     
       translate <-0.35,-0.35,-0.5>
       parallelize(<0,0,-1>, triangle_normal(corner_1, corner_2, corner_3))
       scale <0.5,0.5,0.2>
       translate 0.2*v1+corner_2
     }     
#local v1=vnormalize(corner_3-triangle_H(corner_1, corner_2, corner_3));                   
text { ttf "arial.ttf" "C" 1, 0
       texture { texture_NavyBlue }     
       translate <-0.35,-0.35,-0.5>
       parallelize(<0,0,-1>, triangle_normal(corner_1, corner_2, corner_3))
       scale <0.5,0.5,0.2>
       translate 0.2*v1+corner_3
     }     
     
     
triangle { corner_1, corner_2, corner_3
           fill_slash (0.6)     
           translate 0.01*triangle_normal(corner_1, corner_2, corner_3)
         }     

draw_vector(0, corner_1, 
            0.03,
            texture_NavyBlue)

draw_vector(0, corner_2, 
            0.03,
            texture_NavyBlue)

draw_vector(0, corner_3, 
            0.03,
            texture_NavyBlue)

torus { triangle_r_outer (corner_1, corner_2, corner_3)
        0.03
        texture { texture_M }                             
        parallelize(<0,1,0>, triangle_normal(corner_1, corner_2, corner_3))
        translate triangle_M(corner_1, corner_2, corner_3)
      }                                                   
      
sphere { triangle_M(corner_1, corner_2, corner_3), 0.05
         texture { texture_M }                             
       }      
                                                          
                                                          
#local phi=135*pi/180;                                                          
object { draw_distance( 0, 
                        triangle_r_outer (corner_1, corner_2, corner_3)*<cos(phi),sin(phi),0>, 
                        0.02,
                        texture { texture_M }                             
                      )                                                   
         parallelize(<0,0,1>, triangle_normal(corner_1, corner_2, corner_3))
         translate triangle_M(corner_1, corner_2, corner_3)
       }  

torus { triangle_r_inner (corner_1, corner_2, corner_3)
        0.03
        texture { texture_Y }                             
        parallelize(<0,1,0>, triangle_normal(corner_1, corner_2, corner_3))
        translate triangle_W(corner_1, corner_2, corner_3)
      }                                                                          
                                                   
sphere { triangle_W(corner_1, corner_2, corner_3), 0.05
         texture { texture_Y }                             
       }      

#local phi=15*pi/180;                                                          
object { draw_distance( 0, 
                        triangle_r_inner (corner_1, corner_2, corner_3)*<cos(phi),sin(phi),0>, 
                        0.02,
                        texture { texture_Y }                             
                      )                                                   
         parallelize(<0,0,1>, triangle_normal(corner_1, corner_2, corner_3))
         translate triangle_W(corner_1, corner_2, corner_3)
       }  

draw_vector(triangle_H(corner_1, corner_2, corner_3),                                                    
            triangle_H(corner_1, corner_2, corner_3)+triangle_normal(corner_1, corner_2, corner_3),
            0.03,
            texture { texture_B })

